"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Logger = void 0;
var stream_1 = require("stream");
var util_1 = require("util");
var os_1 = require("os");
var Logger = /** @class */ (function (_super) {
    __extends(Logger, _super);
    function Logger() {
        var _this = _super.call(this, {
            write: function (chunk, _encoding, callback) {
                _this.content.push(chunk);
                callback();
            }
        }) || this;
        _this.content = [];
        return _this;
    }
    Logger.prototype.info = function () {
        var text = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            text[_i] = arguments[_i];
        }
        process.stdout.write(this.formatOutput.apply(this, __spread(text)));
    };
    Logger.prototype.error = function () {
        var text = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            text[_i] = arguments[_i];
        }
        process.stderr.write(this.formatOutput.apply(this, __spread(text)));
    };
    Logger.prototype.getContents = function () {
        return String(Buffer.concat(this.content));
    };
    Logger.prototype.formatOutput = function () {
        var text = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            text[_i] = arguments[_i];
        }
        var output = util_1.format.apply(void 0, __spread(['%s'], text, [os_1.EOL]));
        this.write("" + output + os_1.EOL);
        return output;
    };
    return Logger;
}(stream_1.Writable));
exports.Logger = Logger;
//# sourceMappingURL=logger.js.map